/**
  **************************************************************************
  * @file     main.c
  * @version  v2.0.4
  * @date     2021-11-26
  * @brief    main program
  **************************************************************************
  *                       Copyright notice & Disclaimer
  *
  * The software Board Support Package (BSP) that is made available to 
  * download from Artery official website is the copyrighted work of Artery. 
  * Artery authorizes customers to use, copy, and distribute the BSP 
  * software and its related documentation for the purpose of design and 
  * development in conjunction with Artery microcontrollers. Use of the 
  * software is governed by this copyright notice and the following disclaimer.
  *
  * THIS SOFTWARE IS PROVIDED ON "AS IS" BASIS WITHOUT WARRANTIES,
  * GUARANTEES OR REPRESENTATIONS OF ANY KIND. ARTERY EXPRESSLY DISCLAIMS,
  * TO THE FULLEST EXTENT PERMITTED BY LAW, ALL EXPRESS, IMPLIED OR
  * STATUTORY OR OTHER WARRANTIES, GUARANTEES OR REPRESENTATIONS,
  * INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.
  *
  **************************************************************************
  */



/* Includes ------------------------------------------------------------------*/
#include <stdio.h>
#include "at32f403a_407.h"
#include "at32f403a_407_board.h"
#include "at32f403a_407_clock.h"
#include  <stdarg.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <math.h>
#include "tx_api.h"
#include "usart.h"

TX_THREAD my_thread1;

TX_THREAD my_thread2;

static  TX_MUTEX   AppPrintfSemp;	/* printf */

/*
*********************************************************************************************************
*	  : App_Printf
*	˵: ̰߳ȫprintfʽ		  			  
*	    : ͬprintfĲ
*             CУ޷гݺʵεͺĿʱ,ʡԺָ
*	  ֵ: 
*********************************************************************************************************
*/
static  void  App_Printf(const char *fmt, ...)
{
    char  buf_str[200 + 1]; /* رע⣬printfı϶࣬ע˾ֲĴСǷ */
    va_list   v_args;


    va_start(v_args, fmt);
   (void)vsnprintf((char       *)&buf_str[0],
                   (size_t      ) sizeof(buf_str),
                   (char const *) fmt,
                                  v_args);
    va_end(v_args);

	/*  */
    tx_mutex_get(&AppPrintfSemp, TX_WAIT_FOREVER);

    printf("%s", buf_str);

    tx_mutex_put(&AppPrintfSemp);
}

void my_thread1_entry(ULONG thread_input)
{
  /* Enter into a forever loop. */
  while(1)
  {
    App_Printf("threadx 1 application running...\r\n");
    at32_led_toggle(LED2);
    /* Sleep for 2 tick. */
    tx_thread_sleep(2000);
  }
}
void my_thread2_entry(ULONG thread_input)
{
  /* Enter into a forever loop. */
  while(1)
  {
    App_Printf("threadx 2 application running...\r\n");
    at32_led_toggle(LED3);
    /* Sleep for 1 tick. */
    tx_thread_sleep(1000);
  }
}

void tx_application_define(void *first_unused_memory)
{
  /* Create my_thread! */
  tx_thread_create(&my_thread1, "My Thread 1",
  my_thread1_entry, 0x1234, first_unused_memory, 1024, 3, 3, TX_NO_TIME_SLICE, TX_AUTO_START);
  
  tx_thread_create(&my_thread2, "My Thread 2",
  my_thread2_entry, 0x1234, first_unused_memory+1024, 1024, 1, 1, TX_NO_TIME_SLICE, TX_AUTO_START);
}

/**
  * @brief  Main Function.
  * @param  None
  * @retval None
  */
int main(void)
{

  system_clock_config();

  at32_board_init();
  usart1_init(115200);
  printf("init ok\r\n");
  
  printf("threadX rtos on AT-SART-Board\r\n");

  /* Enter the ThreadX kernel. */
  tx_kernel_enter( );

  for(;;)
  {

  }
}





